{******************************************************}
{     DirDialog component for Delphi 32                }
{                                                      }
{ E-Mail:    amavr@yahoo.com                           }
{ WWW:       http://www.geocities.com/amavr            }
{ Created:   May, 1999                                 }
{ Author:    Albert A. Mavrin                          }
{******************************************************}

unit DirDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI, ShlObj;

type
  TDirDialog = class(TComponent)
  private
    FTitle: string;
    FDirName: string;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function Execute: Boolean;
  published
    { Published declarations }
    property Title: string read FTitle write FTitle;
    property DirName: string read FDirName;
  end;

procedure Register;

implementation

{$R *.DCR}

procedure Register;
begin
  RegisterComponents('Dialogs', [TDirDialog]);
end;

{ TDirDialog }

function TDirDialog.Execute: Boolean;
var
 lpItemID : PItemIDList;
 BrowseInfo : TBrowseInfo;
 DisplayName : array[0..MAX_PATH] of Char;
 TempPath : array[0..MAX_PATH] of Char;
begin
 FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
 BrowseInfo.hwndOwner := Application.Handle;
 BrowseInfo.pszDisplayName := @DisplayName;
 BrowseInfo.lpszTitle := PChar(FTitle);
 BrowseInfo.ulFlags := BIF_RETURNONLYFSDIRS;
 lpItemID := SHBrowseForFolder(BrowseInfo);
 Result := not (lpItemId = nil);
 if lpItemId <> nil then begin
   SHGetPathFromIDList(lpItemID, TempPath);
   FDirName := TempPath;
   GlobalFreePtr(lpItemID);
 end;
end;

end.
